Index: lemon/core.h
===================================================================
--- lemon/core.h	(revision 319)
+++ lemon/core.h	(revision 233)
@@ -895,21 +872,20 @@
     /// \brief Make a copy of the given edge.
     ///
-    /// This function makes a copy of the given edge.
-    GraphCopy& edge(const Edge& edge, TEdge& tedge) {
+    /// Make a copy of the given edge.
+    GraphCopy& edge(TEdge& tedge, const Edge& sedge) {
       _edge_maps.push_back(new _core_bits::ItemCopy<From, Edge,
-                           EdgeRefMap, TEdge>(edge, tedge));
-      return *this;
-    }
-
-    /// \brief Execute copying.
-    ///
-    /// This function executes the copying of the graph along with the
-    /// copying of the assigned data.
+                           EdgeRefMap, TEdge>(tedge, sedge));
+      return *this;
+    }
+
+    /// \brief Executes the copies.
+    ///
+    /// Executes the copies.
     void run() {
       NodeRefMap nodeRefMap(_from);
       EdgeRefMap edgeRefMap(_from);
-      ArcRefMap arcRefMap(_from, _to, edgeRefMap, nodeRefMap);
+      ArcRefMap arcRefMap(_to, _from, edgeRefMap, nodeRefMap);
       _core_bits::GraphCopySelector<To>::
-        copy(_from, _to, nodeRefMap, edgeRefMap);
+        copy(_to, _from, nodeRefMap, edgeRefMap);
       for (int i = 0; i < int(_node_maps.size()); ++i) {
         _node_maps[i]->copy(_from, nodeRefMap);
@@ -929,11 +905,11 @@
 
     std::vector<_core_bits::MapCopyBase<From, Node, NodeRefMap>* >
-      _node_maps;
+    _node_maps;
 
     std::vector<_core_bits::MapCopyBase<From, Arc, ArcRefMap>* >
-      _arc_maps;
+    _arc_maps;
 
     std::vector<_core_bits::MapCopyBase<From, Edge, EdgeRefMap>* >
-      _edge_maps;
+    _edge_maps;
 
   };
@@ -941,21 +917,21 @@
   /// \brief Copy a graph to another graph.
   ///
-  /// This function copies a graph to another graph.
-  /// The complete usage of it is detailed in the GraphCopy class,
-  /// but a short example shows a basic work:
+  /// Copy a graph to another graph. The complete usage of the
+  /// function is detailed in the GraphCopy class, but a short
+  /// example shows a basic work:
   ///\code
-  /// graphCopy(src, trg).nodeRef(nr).edgeCrossRef(ecr).run();
+  /// copyGraph(trg, src).nodeRef(nr).arcCrossRef(ecr).run();
   ///\endcode
   ///
   /// After the copy the \c nr map will contain the mapping from the
   /// nodes of the \c from graph to the nodes of the \c to graph and
-  /// \c ecr will contain the mapping from the edges of the \c to graph
-  /// to the edges of the \c from graph.
+  /// \c ecr will contain the mapping from the arcs of the \c to graph
+  /// to the arcs of the \c from graph.
   ///
   /// \see GraphCopy
-  template <typename From, typename To>
-  GraphCopy<From, To>
-  graphCopy(const From& from, To& to) {
-    return GraphCopy<From, To>(from, to);
+  template <typename To, typename From>
+  GraphCopy<To, From>
+  copyGraph(To& to, const From& from) {
+    return GraphCopy<To, From>(to, from);
   }
 
@@ -982,5 +958,5 @@
     struct FindArcSelector<
       Graph,
-      typename enable_if<typename Graph::FindArcTag, void>::type>
+      typename enable_if<typename Graph::FindEdgeTag, void>::type>
     {
       typedef typename Graph::Node Node;
@@ -992,8 +968,7 @@
   }
 
-  /// \brief Find an arc between two nodes of a digraph.
-  ///
-  /// This function finds an arc from node \c u to node \c v in the
-  /// digraph \c g.
+  /// \brief Finds an arc between two nodes of a graph.
+  ///
+  /// Finds an arc from node \c u to node \c v in graph \c g.
   ///
   /// If \c prev is \ref INVALID (this is the default value), then
@@ -1004,14 +979,13 @@
   /// Thus you can iterate through each arc from \c u to \c v as it follows.
   ///\code
-  /// for(Arc e = findArc(g,u,v); e != INVALID; e = findArc(g,u,v,e)) {
+  /// for(Arc e=findArc(g,u,v);e!=INVALID;e=findArc(g,u,v,e)) {
   ///   ...
   /// }
   ///\endcode
   ///
-  /// \note \ref ConArcIt provides iterator interface for the same
-  /// functionality.
-  ///
+  ///\sa ArcLookUp
+  ///\sa AllArcLookUp
+  ///\sa DynArcLookUp
   ///\sa ConArcIt
-  ///\sa ArcLookUp, AllArcLookUp, DynArcLookUp
   template <typename Graph>
   inline typename Graph::Arc
@@ -1021,8 +995,8 @@
   }
 
-  /// \brief Iterator for iterating on parallel arcs connecting the same nodes.
-  ///
-  /// Iterator for iterating on parallel arcs connecting the same nodes. It is
-  /// a higher level interface for the \ref findArc() function. You can
+  /// \brief Iterator for iterating on arcs connected the same nodes.
+  ///
+  /// Iterator for iterating on arcs connected the same nodes. It is
+  /// higher level interface for the findArc() function. You can
   /// use it the following way:
   ///\code
@@ -1033,5 +1007,7 @@
   ///
   ///\sa findArc()
-  ///\sa ArcLookUp, AllArcLookUp, DynArcLookUp
+  ///\sa ArcLookUp
+  ///\sa AllArcLookUp
+  ///\sa DynArcLookUp
   template <typename _Graph>
   class ConArcIt : public _Graph::Arc {
@@ -1046,6 +1022,6 @@
     /// \brief Constructor.
     ///
-    /// Construct a new ConArcIt iterating on the arcs that
-    /// connects nodes \c u and \c v.
+    /// Construct a new ConArcIt iterating on the arcs which
+    /// connects the \c u and \c v node.
     ConArcIt(const Graph& g, Node u, Node v) : _graph(g) {
       Parent::operator=(findArc(_graph, u, v));
@@ -1054,5 +1030,6 @@
     /// \brief Constructor.
     ///
-    /// Construct a new ConArcIt that continues the iterating from arc \c a.
+    /// Construct a new ConArcIt which continues the iterating from
+    /// the \c e arc.
     ConArcIt(const Graph& g, Arc a) : Parent(a), _graph(g) {}
 
@@ -1115,27 +1092,25 @@
   }
 
-  /// \brief Find an edge between two nodes of a graph.
-  ///
-  /// This function finds an edge from node \c u to node \c v in graph \c g.
-  /// If node \c u and node \c v is equal then each loop edge
+  /// \brief Finds an edge between two nodes of a graph.
+  ///
+  /// Finds an edge from node \c u to node \c v in graph \c g.
+  /// If the node \c u and node \c v is equal then each loop edge
   /// will be enumerated once.
   ///
   /// If \c prev is \ref INVALID (this is the default value), then
-  /// it finds the first edge from \c u to \c v. Otherwise it looks for
-  /// the next edge from \c u to \c v after \c prev.
-  /// \return The found edge or \ref INVALID if there is no such an edge.
-  ///
-  /// Thus you can iterate through each edge between \c u and \c v
-  /// as it follows.
+  /// it finds the first arc from \c u to \c v. Otherwise it looks for
+  /// the next arc from \c u to \c v after \c prev.
+  /// \return The found arc or \ref INVALID if there is no such an arc.
+  ///
+  /// Thus you can iterate through each arc from \c u to \c v as it follows.
   ///\code
-  /// for(Edge e = findEdge(g,u,v); e != INVALID; e = findEdge(g,u,v,e)) {
+  /// for(Edge e = findEdge(g,u,v); e != INVALID;
+  ///     e = findEdge(g,u,v,e)) {
   ///   ...
   /// }
   ///\endcode
   ///
-  /// \note \ref ConEdgeIt provides iterator interface for the same
-  /// functionality.
-  ///
   ///\sa ConEdgeIt
+
   template <typename Graph>
   inline typename Graph::Edge
@@ -1145,11 +1120,11 @@
   }
 
-  /// \brief Iterator for iterating on parallel edges connecting the same nodes.
-  ///
-  /// Iterator for iterating on parallel edges connecting the same nodes.
-  /// It is a higher level interface for the findEdge() function. You can
+  /// \brief Iterator for iterating on edges connected the same nodes.
+  ///
+  /// Iterator for iterating on edges connected the same nodes. It is
+  /// higher level interface for the findEdge() function. You can
   /// use it the following way:
   ///\code
-  /// for (ConEdgeIt<Graph> it(g, u, v); it != INVALID; ++it) {
+  /// for (ConEdgeIt<Graph> it(g, src, trg); it != INVALID; ++it) {
   ///   ...
   /// }
@@ -1169,6 +1144,6 @@
     /// \brief Constructor.
     ///
-    /// Construct a new ConEdgeIt iterating on the edges that
-    /// connects nodes \c u and \c v.
+    /// Construct a new ConEdgeIt iterating on the edges which
+    /// connects the \c u and \c v node.
     ConEdgeIt(const Graph& g, Node u, Node v) : _graph(g) {
       Parent::operator=(findEdge(_graph, u, v));
@@ -1177,5 +1152,6 @@
     /// \brief Constructor.
     ///
-    /// Construct a new ConEdgeIt that continues iterating from edge \c e.
+    /// Construct a new ConEdgeIt which continues the iterating from
+    /// the \c e edge.
     ConEdgeIt(const Graph& g, Edge e) : Parent(e), _graph(g) {}
 
@@ -1193,8 +1169,8 @@
 
 
-  ///Dynamic arc look-up between given endpoints.
+  ///Dynamic arc look up between given endpoints.
 
   ///Using this class, you can find an arc in a digraph from a given
-  ///source to a given target in amortized time <em>O</em>(log<em>d</em>),
+  ///source to a given target in amortized time <em>O(log</em>d<em>)</em>,
   ///where <em>d</em> is the out-degree of the source node.
   ///
@@ -1202,10 +1178,10 @@
   ///the \c operator() member.
   ///
-  ///This is a dynamic data structure. Consider to use \ref ArcLookUp or
-  ///\ref AllArcLookUp if your digraph is not changed so frequently.
-  ///
-  ///This class uses a self-adjusting binary search tree, the Splay tree
-  ///of Sleator and Tarjan to guarantee the logarithmic amortized
-  ///time bound for arc look-ups. This class also guarantees the
+  ///See the \ref ArcLookUp and \ref AllArcLookUp classes if your
+  ///digraph is not changed so frequently.
+  ///
+  ///This class uses a self-adjusting binary search tree, Sleator's
+  ///and Tarjan's Splay tree for guarantee the logarithmic amortized
+  ///time bound for arc lookups. This class also guarantees the
   ///optimal time bound in a constant factor for any distribution of
   ///queries.
@@ -1532,6 +1508,6 @@
 
     ///Find an arc between two nodes.
-    ///\param s The source node.
-    ///\param t The target node.
+    ///\param s The source node
+    ///\param t The target node
     ///\param p The previous arc between \c s and \c t. It it is INVALID or
     ///not given, the operator finds the first appropriate arc.
@@ -1544,9 +1520,9 @@
     ///DynArcLookUp<ListDigraph> ae(g);
     ///...
-    ///int n = 0;
-    ///for(Arc a = ae(u,v); a != INVALID; a = ae(u,v,a)) n++;
+    ///int n=0;
+    ///for(Arc e=ae(u,v);e!=INVALID;e=ae(u,v,e)) n++;
     ///\endcode
     ///
-    ///Finding the arcs take at most <em>O</em>(log<em>d</em>)
+    ///Finding the arcs take at most <em>O(</em>log<em>d)</em>
     ///amortized time, specifically, the time complexity of the lookups
     ///is equal to the optimal search tree implementation for the
@@ -1554,8 +1530,9 @@
     ///
     ///\note This is a dynamic data structure, therefore the data
-    ///structure is updated after each graph alteration. Thus although
-    ///this data structure is theoretically faster than \ref ArcLookUp
-    ///and \ref AllArcLookUp, it often provides worse performance than
+    ///structure is updated after each graph alteration. However,
+    ///theoretically this data structure is faster than \c ArcLookUp
+    ///or AllEdgeLookup, but it often provides worse performance than
     ///them.
+    ///
     Arc operator()(Node s, Node t, Arc p = INVALID) const  {
       if (p == INVALID) {
@@ -1609,8 +1586,8 @@
   };
 
-  ///Fast arc look-up between given endpoints.
+  ///Fast arc look up between given endpoints.
 
   ///Using this class, you can find an arc in a digraph from a given
-  ///source to a given target in time <em>O</em>(log<em>d</em>),
+  ///source to a given target in time <em>O(log d)</em>,
   ///where <em>d</em> is the out-degree of the source node.
   ///
@@ -1618,8 +1595,8 @@
   ///Use \ref AllArcLookUp for this purpose.
   ///
-  ///\warning This class is static, so you should call refresh() (or at
-  ///least refresh(Node)) to refresh this data structure whenever the
-  ///digraph changes. This is a time consuming (superlinearly proportional
-  ///(<em>O</em>(<em>m</em> log<em>m</em>)) to the number of arcs).
+  ///\warning This class is static, so you should refresh() (or at least
+  ///refresh(Node)) this data structure
+  ///whenever the digraph changes. This is a time consuming (superlinearly
+  ///proportional (<em>O(m</em>log<em>m)</em>) to the number of arcs).
   ///
   ///\tparam G The type of the underlying digraph.
@@ -1670,10 +1647,10 @@
     }
   public:
-    ///Refresh the search data structure at a node.
+    ///Refresh the data structure at a node.
 
     ///Build up the search database of node \c n.
     ///
-    ///It runs in time <em>O</em>(<em>d</em> log<em>d</em>), where <em>d</em>
-    ///is the number of the outgoing arcs of \c n.
+    ///It runs in time <em>O(d</em>log<em>d)</em>, where <em>d</em> is
+    ///the number of the outgoing arcs of \c n.
     void refresh(Node n)
     {
@@ -1691,7 +1668,8 @@
     ///\ref refresh(Node) "refresh(n)" for each node \c n.
     ///
-    ///It runs in time <em>O</em>(<em>m</em> log<em>D</em>), where <em>m</em> is
-    ///the number of the arcs in the digraph and <em>D</em> is the maximum
+    ///It runs in time <em>O(m</em>log<em>D)</em>, where <em>m</em> is
+    ///the number of the arcs of \c n and <em>D</em> is the maximum
     ///out-degree of the digraph.
+
     void refresh()
     {
@@ -1701,8 +1679,8 @@
     ///Find an arc between two nodes.
 
-    ///Find an arc between two nodes in time <em>O</em>(log<em>d</em>),
-    ///where <em>d</em> is the number of outgoing arcs of \c s.
-    ///\param s The source node.
-    ///\param t The target node.
+    ///Find an arc between two nodes in time <em>O(</em>log<em>d)</em>, where
+    /// <em>d</em> is the number of outgoing arcs of \c s.
+    ///\param s The source node
+    ///\param t The target node
     ///\return An arc from \c s to \c t if there exists,
     ///\ref INVALID otherwise.
@@ -1710,5 +1688,7 @@
     ///\warning If you change the digraph, refresh() must be called before using
     ///this operator. If you change the outgoing arcs of
-    ///a single node \c n, then \ref refresh(Node) "refresh(n)" is enough.
+    ///a single node \c n, then
+    ///\ref refresh(Node) "refresh(n)" is enough.
+    ///
     Arc operator()(Node s, Node t) const
     {
@@ -1722,14 +1702,13 @@
   };
 
-  ///Fast look-up of all arcs between given endpoints.
+  ///Fast look up of all arcs between given endpoints.
 
   ///This class is the same as \ref ArcLookUp, with the addition
-  ///that it makes it possible to find all parallel arcs between given
-  ///endpoints.
-  ///
-  ///\warning This class is static, so you should call refresh() (or at
-  ///least refresh(Node)) to refresh this data structure whenever the
-  ///digraph changes. This is a time consuming (superlinearly proportional
-  ///(<em>O</em>(<em>m</em> log<em>m</em>)) to the number of arcs).
+  ///that it makes it possible to find all arcs between given endpoints.
+  ///
+  ///\warning This class is static, so you should refresh() (or at least
+  ///refresh(Node)) this data structure
+  ///whenever the digraph changes. This is a time consuming (superlinearly
+  ///proportional (<em>O(m</em>log<em>m)</em>) to the number of arcs).
   ///
   ///\tparam G The type of the underlying digraph.
@@ -1755,4 +1734,5 @@
       else {
         next=refreshNext(_right[head],next);
+//         _next[head]=next;
         _next[head]=( next!=INVALID && _g.target(next)==_g.target(head))
           ? next : INVALID;
@@ -1779,6 +1759,7 @@
     ///Build up the search database of node \c n.
     ///
-    ///It runs in time <em>O</em>(<em>d</em> log<em>d</em>), where <em>d</em> is
+    ///It runs in time <em>O(d</em>log<em>d)</em>, where <em>d</em> is
     ///the number of the outgoing arcs of \c n.
+
     void refresh(Node n)
     {
@@ -1792,7 +1773,8 @@
     ///\ref refresh(Node) "refresh(n)" for each node \c n.
     ///
-    ///It runs in time <em>O</em>(<em>m</em> log<em>D</em>), where <em>m</em> is
-    ///the number of the arcs in the digraph and <em>D</em> is the maximum
+    ///It runs in time <em>O(m</em>log<em>D)</em>, where <em>m</em> is
+    ///the number of the arcs of \c n and <em>D</em> is the maximum
     ///out-degree of the digraph.
+
     void refresh()
     {
@@ -1803,6 +1785,6 @@
 
     ///Find an arc between two nodes.
-    ///\param s The source node.
-    ///\param t The target node.
+    ///\param s The source node
+    ///\param t The target node
     ///\param prev The previous arc between \c s and \c t. It it is INVALID or
     ///not given, the operator finds the first appropriate arc.
@@ -1815,15 +1797,16 @@
     ///AllArcLookUp<ListDigraph> ae(g);
     ///...
-    ///int n = 0;
-    ///for(Arc a = ae(u,v); a != INVALID; a=ae(u,v,a)) n++;
+    ///int n=0;
+    ///for(Arc e=ae(u,v);e!=INVALID;e=ae(u,v,e)) n++;
     ///\endcode
     ///
-    ///Finding the first arc take <em>O</em>(log<em>d</em>) time,
-    ///where <em>d</em> is the number of outgoing arcs of \c s. Then the
+    ///Finding the first arc take <em>O(</em>log<em>d)</em> time, where
+    /// <em>d</em> is the number of outgoing arcs of \c s. Then, the
     ///consecutive arcs are found in constant time.
     ///
     ///\warning If you change the digraph, refresh() must be called before using
     ///this operator. If you change the outgoing arcs of
-    ///a single node \c n, then \ref refresh(Node) "refresh(n)" is enough.
+    ///a single node \c n, then
+    ///\ref refresh(Node) "refresh(n)" is enough.
     ///
 #ifdef DOXYGEN
